<?php

$areaConfig   = file_get_contents('area-config.json');
$areaTemplate = file_get_contents('area-script-template.baf');
$cutTemplate  = file_get_contents('cutscene-template.baf');

$areas = json_decode($areaConfig, true);

foreach ($areas as $area) {
	if ($argc > 1 && !in_array($area['AreaCode'], $argv, true)) continue;
	
	$origin = $area['Location'];
	
	$p1location = sprintf('[%u.%u]', $origin[0], $origin[1]+50);
	$p2location = sprintf('[%u.%u]', $origin[0]-40, $origin[1]+25);
	$p3location = sprintf('[%u.%u]', $origin[0]-40, $origin[1]-25);
	$p4location = sprintf('[%u.%u]', $origin[0], $origin[1]-50);
	$p5location = sprintf('[%u.%u]', $origin[0]+50, $origin[1]-25);
	$p6location = sprintf('[%u.%u]', $origin[0]+50, $origin[1]+25);
	
	$areaScript = str_replace('%AREACODE%', $area['AreaCode'], $areaTemplate);
	$cutScript  = str_replace('%AREACODE%', $area['AreaCode'], $cutTemplate);
	$cutScript  = str_replace('%P1LOCATION%', $p1location, $cutScript);
	$cutScript  = str_replace('%P2LOCATION%', $p2location, $cutScript);
	$cutScript  = str_replace('%P3LOCATION%', $p3location, $cutScript);
	$cutScript  = str_replace('%P4LOCATION%', $p4location, $cutScript);
	$cutScript  = str_replace('%P5LOCATION%', $p5location, $cutScript);
	$cutScript  = str_replace('%P6LOCATION%', $p6location, $cutScript);
	
	file_put_contents(sprintf('generated/%s.baf', $area['AreaCode']), $areaScript);
	file_put_contents(sprintf('generated/D!%s.baf', $area['AreaCode']), $cutScript);
}